package org.processmining.models.operationalsupport;

import java.util.ArrayList;

/**
 * 
 * @author mschonen; joyce nakatumba
 * 
 */
public class Recommendation extends Prediction {
	private WorkItem workItem;
	private ArrayList<RecommendationItem> recItems;

	public Recommendation(String text, ArrayList<RecommendationItem> recItems) {
		super(text);
		this.recItems = recItems;
	}

	// TODO should not be in the recommendation, but input for the provider plugins
	public Recommendation(String text, WorkItem workItem) {
		super(text);

		this.workItem = workItem;

		Attributes att = getAttributes("Recommended action");
		att.put("task", workItem.getTask());
		att.put("transition", workItem.getTransition());
		att.put("value", Math.random());
		ArrayList<String> auth = new ArrayList<String>();
		for (String r : workItem.getAuthorizedResources()) {
			auth.add(r);
		}
		att.put("authorized", auth);

	}

	public WorkItem getWorkItem() {
		return workItem;
	}

	public ArrayList<RecommendationItem> getRecItems() {
		return recItems;
	}
}