package org.processmining.models.operationalsupport.gui;

import java.awt.Component;

import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellRenderer;

import org.processmining.framework.util.IconLoader;
import org.processmining.models.operationalsupport.Analysis;
import org.processmining.models.operationalsupport.Prediction;
import org.processmining.models.operationalsupport.Recommendation;

public class OSTreeCellRenderer implements TreeCellRenderer {

	private static final long serialVersionUID = 1L;

	private final DefaultTreeCellRenderer componentRenderer;
	private final DefaultTreeCellRenderer nodeRenderer;

	public OSTreeCellRenderer() {
		super();
		componentRenderer = new DefaultTreeCellRenderer();
		nodeRenderer = new DefaultTreeCellRenderer();
	}

	public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded,
			boolean leaf, int row, boolean hasFocus) {
		Component returnValue = null;
		if (value instanceof DefaultMutableTreeNode) {
			Object userObject = ((DefaultMutableTreeNode) value).getUserObject();
			if (userObject instanceof OSNode) {
				Analysis a = ((OSNode) userObject).getAnalysis();
				String text = a.getText();

				componentRenderer.getTreeCellRendererComponent(tree, text, selected, expanded, leaf, row, hasFocus);

				ImageIcon leafIcon = IconLoader.getProMLibIcon("analysis");
				if (a instanceof Prediction) {
					leafIcon = IconLoader.getProMLibIcon("prediction");
				} else if (a instanceof Recommendation) {
					leafIcon = IconLoader.getProMLibIcon("recommendation");
				}
				componentRenderer.setText(text);
				//ImageIcon leafIcon = new ImageIcon(insertUrl);
				componentRenderer.setIcon(leafIcon);
				return componentRenderer;
			} else {
				if (userObject instanceof HTMLAttributes) {
					//returnValue = nodeRenderer.getTreeCellRendererComponent(tree,
					//		getAttributes((Attributes) userObject), selected, expanded, leaf, row, hasFocus);
					returnValue = nodeRenderer.getTreeCellRendererComponent(tree, ((HTMLAttributes) userObject)
							.getHtml(), selected, expanded, leaf, row, hasFocus);
					nodeRenderer.setIcon(null);
				} else {
					returnValue = nodeRenderer.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row,
							hasFocus);
				}
			}
		}

		return returnValue;
	}

	/*
	 * private String getAttributes(Attributes a) { String html =
	 * "<html> <table border=\"1\" width=\"10\">" + " <tr bgcolor=\"#C0C0C0\">";
	 * for (String name : a.keySet()) { html += " <td >" + name + "</td>"; }
	 * html += " </tr> "; html += " <tr> "; for (String name : a.keySet()) {
	 * html += "<td>" + a.get(name) + "</td>"; } html += "</tr>"; html +=
	 * "</table>"; html += "</html>"; return html; }
	 */
}
